## ros-galactic-hardware-interface 1.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(hardware_interface)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake REQUIRED)
find_package(control_msgs REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(tinyxml2_vendor REQUIRED)
find_package(TinyXML2 REQUIRED)

add_library(
  hardware_interface
  SHARED
  src/actuator.cpp
  src/component_parser.cpp
  src/resource_manager.cpp
  src/sensor.cpp
  src/system.cpp
)
target_include_directories(
  hardware_interface
  PUBLIC
  include
)
ament_target_dependencies(
  hardware_interface
  control_msgs
  lifecycle_msgs
  pluginlib
  rclcpp_lifecycle
  rcutils
  rcpputils
)
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(hardware_interface PRIVATE "HARDWARE_INTERFACE_BUILDING_DLL")

# Fake components
add_library(
  fake_components
  SHARED
  src/fake_components/generic_system.cpp
)
target_include_directories(
  fake_components
  PUBLIC
  include
)
target_link_libraries(
  fake_components
  hardware_interface
)
ament_target_dependencies(
  fake_components
  pluginlib
  rcpputils
)
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(fake_components PRIVATE "HARDWARE_INTERFACE_BUILDING_DLL")

pluginlib_export_plugin_description_file(
  hardware_interface fake_components_plugin_description.xml)

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS
  fake_components
  hardware_interface
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  list(APPEND AMENT_LINT_AUTO_EXCLUDE
    ament_cmake_uncrustify
    ament_cmake_cpplint
  )
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gmock REQUIRED)
  find_package(ros2_control_test_assets REQUIRED)

  ament_add_gmock(test_macros test/test_macros.cpp)
  target_include_directories(test_macros PRIVATE include)
  ament_target_dependencies(test_macros rcpputils)

  ament_add_gmock(test_joint_handle test/test_handle.cpp)
  target_link_libraries(test_joint_handle hardware_interface)
  ament_target_dependencies(test_joint_handle rcpputils)

  ament_add_gmock(test_component_interfaces test/test_component_interfaces.cpp)
  target_link_libraries(test_component_interfaces hardware_interface)

  ament_add_gmock(test_component_parser test/test_component_parser.cpp)
  target_link_libraries(test_component_parser hardware_interface)
  ament_target_dependencies(test_component_parser ros2_control_test_assets)

  add_library(test_components SHARED
    test/test_components/test_actuator.cpp
    test/test_components/test_sensor.cpp
    test/test_components/test_system.cpp)
  target_link_libraries(test_components hardware_interface)
  ament_target_dependencies(test_components
    pluginlib)
  install(TARGETS test_components
    DESTINATION lib
  )
  pluginlib_export_plugin_description_file(
    hardware_interface test/test_components/test_components.xml)

  add_library(test_hardware_components SHARED
  test/test_hardware_components/test_single_joint_actuator.cpp
  test/test_hardware_components/test_force_torque_sensor.cpp
  test/test_hardware_components/test_two_joint_system.cpp
  test/test_hardware_components/test_system_with_command_modes.cpp
  )
  target_link_libraries(test_hardware_components hardware_interface)
  ament_target_dependencies(test_hardware_components
    pluginlib)
  install(TARGETS test_hardware_components
    DESTINATION lib
  )
  pluginlib_export_plugin_description_file(
    hardware_interface test/test_hardware_components/test_hardware_components.xml
  )

  ament_add_gmock(test_resource_manager test/test_resource_manager.cpp)
  target_link_libraries(test_resource_manager hardware_interface)
  ament_target_dependencies(test_resource_manager ros2_control_test_assets)

  ament_add_gmock(test_generic_system test/fake_components/test_generic_system.cpp)
  target_include_directories(test_generic_system PRIVATE include)
  target_link_libraries(test_generic_system hardware_interface)
  ament_target_dependencies(test_generic_system
    pluginlib
    ros2_control_test_assets
  )
endif()

ament_export_include_directories(
  include
)
ament_export_libraries(
  fake_components
  hardware_interface
)
ament_export_dependencies(
  control_msgs
  lifecycle_msgs
  rclcpp_lifecycle
  pluginlib
  rcpputils
  tinyxml2_vendor
  TinyXML2
)
ament_package()

=== debian/changelog ===
ros-galactic-hardware-interface (1.6.0-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 02 Aug 2022 23:00:00 -0000

ros-galactic-hardware-interface (1.5.1-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 30 May 2022 23:00:00 -0000

ros-galactic-hardware-interface (1.5.0-1focal) focal; urgency=high

  * Require lifecycle-msgs in hardware_interface package (#675 <https://github.com/ros-controls/ros2_control/issues/675>)
  * Contributors: Martin Wudenka

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 28 Apr 2022 23:00:00 -0000

ros-galactic-hardware-interface (1.4.0-1focal) focal; urgency=high

  * Extend FakeHardware to support <gpio>-tag (#574 <https://github.com/ros-controls/ros2_control/issues/574>) (#634 <https://github.com/ros-controls/ros2_control/issues/634>)
  * Contributors: Subhas Das

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 18 Feb 2022 00:00:00 -0000

ros-galactic-hardware-interface (1.3.0-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 21 Dec 2021 00:00:00 -0000

ros-galactic-hardware-interface (1.2.0-1focal) focal; urgency=high

  * Import and Initialize components (#566 <https://github.com/ros-controls/ros2_control/issues/566>)
  * Contributors: Alejandro Hernández Cordero

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 05 Nov 2021 00:00:00 -0000

ros-galactic-hardware-interface (1.1.0-1focal) focal; urgency=high

  * Handle errors of hardware that happen on read and write. (#546 <https://github.com/ros-controls/ros2_control/issues/546>)
  * Contributors: Denis Štogl, Mathias Aarbo

 -- Karsten Knese <karsten@osrfoundation.org>  Sun, 24 Oct 2021 23:00:00 -0000

ros-galactic-hardware-interface (1.0.0-1focal) focal; urgency=high

  * Hardware components extension for lifecycle support (#503 <https://github.com/ros-controls/ros2_control/issues/503>)
  * add M_PI macro for windows in test_component_parser.cpp (#502 <https://github.com/ros-controls/ros2_control/issues/502>)
  * Extend GenericSystem by adding mapping of position with offset to custom interface. (#469 <https://github.com/ros-controls/ros2_control/issues/469>)
  * Remove BOOST compiler definitions for pluginlib from CMakeLists (#514 <https://github.com/ros-controls/ros2_control/issues/514>)
  * Do not manually set C++ version to 14 (#516 <https://github.com/ros-controls/ros2_control/issues/516>)
  * Contributors: Bence Magyar, Denis Štogl, dzyGIT

 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 28 Sep 2021 23:00:00 -0000

ros-galactic-hardware-interface (0.8.0-1focal) focal; urgency=high

  * Use clang format as code formatter (#491 <https://github.com/ros-controls/ros2_control/issues/491>)
  * Fixup doc typo (#492 <https://github.com/ros-controls/ros2_control/issues/492>)
  * Add docs for fake components (#466 <https://github.com/ros-controls/ros2_control/issues/466>)
  * sort interfaces in resource manager (#483 <https://github.com/ros-controls/ros2_control/issues/483>)
  * fix format (#484 <https://github.com/ros-controls/ros2_control/issues/484>)
  * Transmission parsing v2 (#471 <https://github.com/ros-controls/ros2_control/issues/471>)
    * move parsing responsibility to hardware_interface
    * parse transmission type
    * Cleanup unused parser
  * Add pre-commit setup. (#473 <https://github.com/ros-controls/ros2_control/issues/473>)
  * Extended GenericSystem with state offset options for testing some special control cases. (#350 <https://github.com/ros-controls/ros2_control/issues/350>)
    * Extended GenericSystem with state offset options for testing some special control cases.
    * Better parameter name
    * Apply offset only to position interfaces.
  * Added GPIO parsing and test (#436 <https://github.com/ros-controls/ros2_control/issues/436>)
  * Fixes for windows (#443 <https://github.com/ros-controls/ros2_control/issues/443>)
    * Fix building on windows
    * Fix MSVC linker error when building tests
    * Fix hang when loading controller on windows
    * Use better log for configuring controller
    * Be consistent with visibility control
    * Use try_lock throw exception on failure
  * Contributors: Akash, Bence Magyar, Denis Štogl, Karsten Knese, Mathias Arbo, Jafar Abdi

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 27 Aug 2021 23:00:00 -0000

ros-galactic-hardware-interface (0.7.1-1focal) focal; urgency=high

  * [FakeSystem] Set default command interface to NaN (#424 <https://github.com/ros-controls/ros2_control/issues/424>)
  * Contributors: Denis Štogl, Bence Magyar

 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 14 Jun 2021 23:00:00 -0000

ros-galactic-hardware-interface (0.7.0-1focal) focal; urgency=high

  * Add FTS as first semantic components to simplify controllers. (#370 <https://github.com/ros-controls/ros2_control/issues/370>)
  * Contributors: bailaC, Denis Štogl, Jordan Palacios

 -- Karsten Knese <karsten@osrfoundation.org>  Sat, 05 Jun 2021 23:00:00 -0000

ros-galactic-hardware-interface (0.6.1-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Sun, 30 May 2021 23:00:00 -0000

ros-galactic-hardware-interface (0.6.0-1focal) focal; urgency=high

  * Remove the with_value_ptr and class templatization for ReadOnlyHandle (#379 <https://github.com/ros-controls/ros2_control/issues/379>)
  * fake_components: Add mimic joint to generic system (#409 <https://github.com/ros-controls/ros2_control/issues/409>)
  * List controller claimed interfaces (#407 <https://github.com/ros-controls/ros2_control/issues/407>)
  * Contributors: El Jawad Alaa, Jafar Abdi, Jordan Palacios, Bence Magyar

 -- Karsten Knese <karsten@osrfoundation.org>  Sat, 22 May 2021 23:00:00 -0000

ros-galactic-hardware-interface (0.5.0-1focal) focal; urgency=high

  * Make hardware interface types as const char array rather than const char pointer (#408 <https://github.com/ros-controls/ros2_control/issues/408>)


=== debian/control ===
Source: ros-galactic-hardware-interface
Section: misc
Priority: optional
Maintainer: Karsten Knese <karsten@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-cmake-gmock, ros-galactic-ament-lint-auto, ros-galactic-ament-lint-common, ros-galactic-control-msgs, ros-galactic-lifecycle-msgs, ros-galactic-pluginlib, ros-galactic-rclcpp-lifecycle, ros-galactic-rcpputils, ros-galactic-rcutils, ros-galactic-ros2-control-test-assets, ros-galactic-tinyxml2-vendor, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-hardware-interface
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-control-msgs, ros-galactic-lifecycle-msgs, ros-galactic-pluginlib, ros-galactic-rclcpp-lifecycle, ros-galactic-rcpputils, ros-galactic-rcutils, ros-galactic-tinyxml2-vendor, ros-galactic-ros-workspace
Description: ROS2 ros_control hardware interface

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-hardware-interface//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
